Global( "ShipId", {})
Global( "Ship", {})
Global( "DeviceId", {})
Global( "Device", {})
Global( "Shield", {})
Global( "Shields", {})
Global( "MainPanel", mainForm:GetChildChecked("MainPanel", false))
Global( "Artillery", MainPanel:GetChildChecked("Artillery", false):GetWidgetDesc())
Global( "Color", {
	["Red"] = {r = .9; g = 0.2; b = 0; a = .8},
	["Green"] = {r = 0.08; g = 0.64; b = 0.18; a = .8},
	["Orange"] = {r = .8; g = 0.35; b = 0.02; a = .8},
	["Blue"] = {r = 0.09; g = 0.52; b = 0.95; a = .8},
	["Yellow"] = {r = .9; g = .9; b = 0; a = .8},
	["Black"] = {r = .3; g = .3; b = .3; a = .8},
})
-------------------------------------------------------------------------------
-- FUNCTION
-------------------------------------------------------------------------------
function ColorCheck( sender, health )
	sender:Show(true)
	if health == 100 then
		sender:SetBackgroundColor(Color["Blue"])
	elseif health >= 75 then
		sender:SetBackgroundColor(Color["Green"])
	elseif health >= 50 then
		sender:SetBackgroundColor(Color["Yellow"])
	elseif health >= 25 then
		sender:SetBackgroundColor(Color["Orange"])
	elseif health > 0 then
		sender:SetBackgroundColor(Color["Red"])
	else
		sender:SetBackgroundColor(Color["Black"])
	end
end

function ShieldCheck( name, side, shield )
	local count
	local color
	if shield == 100 then
		count = 5
		color = "Blue"
	elseif shield >= 80 then
		count = 4
		color = "Green"
	elseif shield >= 60 then
		count = 3
		color = "Yellow"
	elseif shield >= 40 then
		count = 2
		color = "Orange"
	elseif shield >= 20 then
		count = 1
		color = "Red"
	else
		count = 0
		color = "Black"
	end
	if count == 0 then
		Shields[name.."Shield"..side..1]:Show(true)
	elseif count >= 1 and count < 5 then
		Shields[name.."Shield"..side..count]:Show(true)
		for i = 1, count do
			Shields[name.."Shield"..side..i]:Show(true)
		end
		for i = count + 1, 5 do
			Shields[name.."Shield"..side..i]:Show(false)
		end
	elseif count == 5 then
		Shields[name.."Shield"..side..count]:GetParent():Show(true)
		for i = 1, count do
			Shields[name.."Shield"..side..i]:Show(true)
		end
	end
	for i = 1, 5 do
		Shields[name.."Shield"..side..i]:SetBackgroundColor(Color[color])
	end
end

function GetShipData(trans)
	if trans then
		mainForm:Show(true)
		local transname = userMods.FromWString(object.GetName(trans))
		ShipId[transname] = trans
		if not Ship[transname] then
			Ship[transname] = mainForm:CreateWidgetByDesc(MainPanel:GetWidgetDesc())
		end
		local DragPanel = Ship[transname]:GetChildChecked("DragPanel", false)
		DragPanel:SetBackgroundColor({r=0;g=0;b=0;a=.4})
		DnD:Init( 992, DragPanel, Ship[transname], true)
		local tHealthPer = math.ceil(transport.GetHealth(trans).value / transport.GetHealth(trans).limit * 100)
		Ship[transname]:GetChildChecked("Ship", false):SetPriority(0)
		ColorCheck( Ship[transname]:GetChildChecked("Ship", false), tHealthPer )
		for i = 2, 5 do
			Shield[transname.."ShieldSide"..i] = Ship[transname]:GetChildChecked("ShieldSide"..i, false)
			local child = Shield[transname.."ShieldSide"..i]:GetChildChecked("Shield"..i, false):GetWidgetDesc()
			for x = 1, 5 do
				Shields[transname.."Shield"..i..x] = mainForm:CreateWidgetByDesc(child)
				Shield[transname.."ShieldSide"..i]:AddChild(Shields[transname.."Shield"..i..x])
				local P = Shields[transname.."Shield"..i..x]:GetPlacementPlain()
				if i == 2 then
					P.posY = P.posY - (4 * x) + 10
					P.sizeX = P.sizeX + (3 * x)
					P.posX = P.posX - (1.5 * x)
					P.sizeY = P.sizeY + (2 * x)
				elseif i == 3 then
					P.posY = P.posY + (1 * x) + 15
					P.sizeX = P.sizeX + (3 * x)
					P.sizeY = P.sizeY + (4 * x) + 5
					P.posX = P.posX - (1.5 * x)
				elseif i == 4 then
					P.posX = P.posX - (4 * x)
					P.sizeY = P.sizeY + (2 * x) + 15
					P.posY = P.posY - (1 * x)
					P.sizeX = P.sizeX + (2 * x)
				elseif i == 5 then
					P.posX = P.posX + (2 * x)
					P.sizeY = P.sizeY + (2 * x) + 15
					P.posY = P.posY - (1 * x)
					P.sizeX = P.sizeX + (2 * x)
				end
				Shields[transname.."Shield"..i..x]:SetPlacementPlain(P)
				Shields[transname.."Shield"..i..x]:SetBackgroundColor(Color["Blue"])
			end
			ShieldCheck( transname, i, math.ceil(transport.GetShieldStrength(trans, i).value / transport.GetShieldStrength(trans, i).maxValue * 100))
		end
		local devs = transport.GetDevices(trans)
		local Can = {}
		Can[4] = 0
		Can[5] = 0
		local Art = 0
		local Hel = 0
		local Tur = 0
		local Mot = 0
		local Cannon = {}
		Cannon[4] = MainPanel:GetChildChecked("LCannon", false):GetWidgetDesc()
		Cannon[5] = MainPanel:GetChildChecked("RCannon", false):GetWidgetDesc()
		table.sort(devs, function(a, b) return device.GetShipSlotInfo(a).interfaceSlot < device.GetShipSlotInfo(b).interfaceSlot end)
		for i, v in devs do
			local name = userMods.FromWString(object.GetName(v))
			local idcheck = nil
			local devtype = device.GetUsableDeviceType(v)
			if devtype == USDEV_BEAM_CANNON then
				Device[transname..name..Art] = mainForm:CreateWidgetByDesc(Artillery)
				Ship[transname]:AddChild(Device[transname..name..Art])
				local P = Device[transname..name..Art]:GetPlacementPlain()
				P.posY = 65
				if Art == 0 then
					P.posX = 80
				else
					P.posX = 135
				end
				Device[transname..name..Art]:SetPlacementPlain(P)
				idcheck = transname..name..Art
				Art = 1
			elseif devtype == USDEV_CANNON then
				local P
				local slot = device.GetShipSlotInfo(v).interfaceSlot
				local side = device.GetShipSlotInfo(v).side
				Device[transname..name..side..Can[side]] = mainForm:CreateWidgetByDesc(Cannon[side])
				Ship[transname]:AddChild(Device[transname..name..side..Can[side]])
				P = Device[transname..name..side..Can[side]]:GetPlacementPlain()
				if slot <= 4 and side == 4 then
					P.posX = 60
					P.posY = 125 + ((Can[side]) * 28)
					Can[side] = Can[side] + 1
				elseif slot <= 4 and side == 5 then
					P.posY = 125 + ((Can[side]) * 28)
					P.posX = 140
					Can[side] = Can[side] + 1
				elseif slot > 4 and side == 4 then
					P.posY = 140 + ((Can[side] - 4) * 28)
					P.posX = 75
					Can[side] = Can[side] + 1
				elseif slot > 4 and side == 5 then
					P.posY = 140 + ((Can[side] - 4) * 28)
					P.posX = 125
					Can[side] = Can[side] + 1
				end
				Device[transname..name..side..Can[side]-1]:SetPlacementPlain(P)
				idcheck = transname..name..side..Can[side]-1
			elseif devtype == USDEV_RUDDER then
				Device[transname..name] = Ship[transname]:GetChildChecked("Helm", false)
				idcheck = transname..name
			elseif devtype == USDEV_ENGINE_VERTICAL then
				Device[transname..name] = Ship[transname]:GetChildChecked("Turbine", false)
				idcheck = transname..name
			elseif devtype == USDEV_ENGINE_HORIZONTAL then
				Device[transname..name] = Ship[transname]:GetChildChecked("Motor", false)
				idcheck = transname..name
			elseif devtype == USDEV_REACTOR then
				Device[transname..name] = Ship[transname]:GetChildChecked("Reactor", false)
				local id = transname..name
				ColorCheck(Device[id], math.ceil((transport.GetEnergy(trans).limit - transport.GetEnergy(trans).value) / transport.GetEnergy(trans).limit * 100))
				DeviceId[id] = v
				Ship[transname]:Show(true)
			end
			if idcheck then
				ColorCheck(Device[idcheck], math.ceil(device.GetHealth(v).value / device.GetHealth(v).limit * 100))
				DeviceId[idcheck] = v
			end
		end
	else
		mainForm:Show(false)
	end
end

function DeviceHealthChanged( params )
	for i, v in DeviceId do
		if params.id == v then
			ColorCheck(Device[i], math.ceil(device.GetHealth(v).value / device.GetHealth(v).limit * 100))
		end
	end
end

function ShieldChanged( params )
	for i, v in ShipId do
		if params.id == v then
			ShieldCheck(i, params.side, math.ceil(transport.GetShieldStrength(params.id, params.side).value / transport.GetShieldStrength(params.id, params.side).maxValue * 100))
		end
	end
end

function ShipHealthChanged( params )
	for i, v in ShipId do
		if params.id == v then
			ColorCheck(Ship[i]:GetChildChecked("Ship", false), math.ceil(transport.GetHealth(v).value / transport.GetHealth(v).limit * 100))
		end
	end
end

function ReactorChanged( params )
	for i, v in ShipId do
		if params.id == v then
			local devs = transport.GetDevices(v)
			for j, x in devs do
				for z, d in DeviceId do
					if d == x then
						local devtype = device.GetUsableDeviceType(x)
						if devtype == USDEV_REACTOR then
							ColorCheck(Device[z], math.ceil((transport.GetEnergy(v).limit - transport.GetEnergy(v).value) / transport.GetEnergy(v).limit * 100))
						end
					end
				end
			end
		end
	end
end

function SlashCommand( params )
	if common.IsSubstring(params.text, userMods.ToWString("/shuddnd")) then
		for i, v in Ship do
			local DragPanel = Ship[i]:GetChildChecked("DragPanel", false)
			DragPanel:Show(not DragPanel:IsVisible())
		end
	end
end

function AvatarShip()
	if unit.GetTransport(avatar.GetId()) then
		local trans = unit.GetTransport(avatar.GetId())
		if transport.CanDrawInterface(trans) then
			GetShipData(trans)
		end
	else
		mainForm:Show(false)
	end
end

--ADDON MANAGER COOPERATION
function OnEventAMMemUsageRequest() --MEMORY
	userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

function OnScriptToggleUI( params ) --UI TOGGLE
	mainForm:Show( params.visible )
end
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	common.RegisterEventHandler( AvatarShip, "EVENT_AVATAR_TRANSPORT_CHANGED" )
	common.RegisterEventHandler( DeviceHealthChanged, "EVENT_DEVICE_HEALTH_CHANGED" )
	common.RegisterEventHandler( ShieldChanged, "EVENT_TRANSPORT_SHIELD_CHANGED" )
	common.RegisterEventHandler( ShipHealthChanged, "EVENT_TRANSPORT_HEALTH_CHANGED" )
	common.RegisterEventHandler( SlashCommand, "EVENT_UNKNOWN_SLASH_COMMAND")
	common.RegisterEventHandler( ReactorChanged, "EVENT_TRANSPORT_ENERGY_CHANGED" )
-- ADDON MANAGER EVENTS (MEMORY, DND TOGGLE, UI TOGGLE)
	common.RegisterEventHandler( OnEventAMMemUsageRequest, "U_EVENT_ADDON_MEM_USAGE_REQUEST" )
	common.RegisterEventHandler( OnScriptToggleUI, "SCRIPT_TOGGLE_UI" )

	AvatarShip()
end
--------------------------------------------------------------------------------
common.RegisterEventHandler( Init, "EVENT_AVATAR_CREATED" )
if avatar.IsExist() then
	Init()
end
--------------------------------------------------------------------------------